#!/usr/bin/perl

# initial parameters
$limit=40; # the limit of bookmarks to display

# find bookmarks using spotlight
# Removed condition Kind='Safari bookmark' because it is different in every language installation of Mac OS
#$bookmarksString=`/usr/bin/mdfind "kMDItemKind='Safari bookmark' && kMDItemURL='feed*'"`;
$bookmarksString=`/usr/bin/mdfind "kMDItemContentTypeTree == 'com.apple.safari.bookmark' && kMDItemURL == 'feed*'"`;
@bookmarkFiles=split(/\r?\n/, $bookmarksString);

# extract each bookmark's info
$currentBookmark = 0;
for($bmf=0;$bmf<@bookmarkFiles && $bmf<$limit;$bmf++){
	# generate the command to read file's metadata
	$command="/usr/bin/mdls -name kMDItemDisplayName -name kMDItemURL ".$bookmarkFiles[$bmf]." |";
	open(IN, $command);
	$line = <IN>;
	# extract name
	if($line =~ /kMDItemDisplayName\s*=\s*"(.*)"/){
		$bookmarks[$currentBookmark] = $1;
		# extract url
		$line = <IN>;
		if($line =~ /kMDItemURL\s*=\s*"(.*)"/){
			$bookmarks[$currentBookmark] .= "|=|".$1;
			$bookmarks[$currentBookmark] =~ s/feed:\/\//http:\/\//;
			$currentBookmark++;
		}
	}
	close IN;
}

# sort results
@bookmarks = sort {lc $a cmp lc $b} @bookmarks;

# print the total of bookmarks found
print (@bookmarkFiles*1);
print "\n";
# print results
for($f=0;$f<@bookmarks;$f++){
	print $bookmarks[$f]."\n";
}
